/***********************************************************************/
/*                                                                     */
/*  FILE        :EM3330_35.c                                           */
/*  DATE        :Wed, Sep 21, 2011                                     */
/*  DESCRIPTION :main program file.                                    */
/*  CPU GROUP   :35C                                                   */
/*                                                                     */
/*  This file is generated by Renesas Project Generator (Ver.4.19).    */
/*  NOTE:THIS IS NOT A TYPICAL EXAMPLE.                                */
/***********************************************************************/
#include "sfr_r835c.h"
#include "init.h"
#include "em3330.h"
#include "printser.h"

volatile unsigned char gucSecCnt;
volatile unsigned char gfTelrdy = 0;

void main(void)
{

	unsigned char ucCnt, ucIndex, ucHum, ucDoPrint;
	unsigned int uiID, uiTO;
	signed int siTemp;
	
	init_hsoco();							// init clock system (20 MHz)
	init_uart1();							// init uart for output
	init_int();								// init interrupt pin for RF data
	init_tra();								// init timer 1 as counter with 20 us clock 
	init_trb();								// init timer 2 with interrupt (10 ms) as system timer

	printser("Check EM3330\r\n");			// say hello
	em_initStruct();						// clear sensor structure

	asm("fset i");							// enable interrupts


	while(1)
	{

/* check if any new data received and update sensor list in case
** update earliest after 5 seconds because every telegramm is sent
** about 7 time */

		uiID = em_getData(&siTemp, &ucHum);					// check for new data
		if(uiID)
		{
			ucIndex = em_findIndex(uiID);					// already in list ?
			uiTO = em_getTO(ucIndex);						// get timeout (return 0 if illegal index)

			if(uiTO < (SENS_TO - 5)) 						// if not in list or time out low enough...
			{
				ucIndex = em_setData(uiID, siTemp, ucHum); // update list
				if(ucIndex == 0xff)							// if list if full
					printser("Err: list full.\r\n");		// say error
				ucDoPrint = 1;
			}
		}

/* check every second if something changed and print in case
** and decrement timeout of each sensor in the list */

		if(!gucSecCnt)								// if 1 second is over
		{
			gucSecCnt = 100;						// reload timer for 1 second

			if(ucDoPrint)							// anything changed ? -> output
			{
				ucDoPrint = 0;						// clear flag

				ucCnt = 0;
//				while(em_printIndex(ucCnt++));		// print complete list human readable
				while(em_printIndexCSV(ucCnt++));	// print complete list for data base
				printser("\r\n");
			}
			em_decTO();								// decrement timeout of all sensors
		}
	}
}
/**************************************
** ISR timer RB
** called every 10ms (system timer)
**************************************/
#pragma interrupt/B ISR_trb(vect = 24)
void ISR_trb(void)
{
	if(gucSecCnt)								// decrement counter until 0
		gucSecCnt--;
}
