#include "sfr_r835c.h"
#include "printser.h"
#include "init.h"

unsigned char hex2ascii(unsigned char c)
{
	if(c > 0x09)
		c += 'A'-10;
	else
		c += '0';
	return c;
}

void printser(char* s)
{
	int i=0;
	
	while(s[i])
		uart_sendbyte(s[i++]);
}
void printser_2hex(unsigned char c)
{
	unsigned char d;

	d = hex2ascii((c & 0xf0) >> 4);
	uart_sendbyte(d);

	d = hex2ascii(c & 0x0f);
	uart_sendbyte(d);
}
void printser_4hex(unsigned int c)
{
	unsigned char d1,d2,d3,d4;

	d4= hex2ascii(c & 0x0f);
	c >>= 4;
	d3= hex2ascii(c & 0x0f);
	c >>= 4;
	d2= hex2ascii(c & 0x0f);
	c >>= 4;
	d1= hex2ascii(c & 0x0f);

	uart_sendbyte(d1);
	uart_sendbyte(d2);
	uart_sendbyte(d3);
	uart_sendbyte(d4);
}
void printser_dec(signed long slNum)
{
	unsigned char d[8], ucFlag, ucDat;
	unsigned int i;
	
	if(slNum < 0)
	{
		slNum = -slNum;
		printser_c('-');
	}

	for(i=0;i<8;i++)
	{
		d[i] = slNum%10;
		slNum /= 10;
	}

	ucFlag = 1;
	for(i=0;i<8;i++)
	{
		ucDat = d[7-i];
		if(ucDat)
			ucFlag = 0;

		if( (ucFlag) && (!ucDat) && (i < 7))
		{
//			uart_sendbyte(' ');
		}
		else
			uart_sendbyte(d[7-i]+'0');
	}
}
void sprintser_dec(unsigned long num, unsigned char* buffer)
{
	unsigned int i;

	for(i=0;i<8;i++)
	{
		buffer[7-i] = (num%10) + '0';
		num /= 10;
	}
	buffer[i] = 0;

	i=0;
	while( (buffer[i]=='0') && (i < 7))
		buffer[i++] = ' ';

}
void sprintser_2dec(unsigned char num, unsigned char* buffer)
{
	if(num > 99)
		num = 99;


	if(num < 10)
		buffer[0] = ' ';
	else
		buffer[0] = num/10 + '0';

	buffer[1] = (num%10)+'0';
	buffer[2] = 0;
}
void sprintser_4dec(unsigned long num, unsigned char* buffer)
{
	unsigned int i;

	for(i=0;i<4;i++)
	{
		buffer[3-i] = (num%10) + '0';
		num /= 10;
	}
	buffer[i] = 0;

	i=0;
	while( (buffer[i]=='0') && (i < 3))
		buffer[i++] = ' ';

	}
void sprintser(unsigned char* in, unsigned char* out)
{
	unsigned int i;
	unsigned char c;
	
	i = 0;
	do
	{
		c = in[i];
		out[i] = c;
		i++;
	}
	while(c);
}
void printser_c(char c)
{
	uart_sendbyte(c);
}
void printser_data(unsigned char* buffer, unsigned int len)
{
	while(len--)
		printser_2hex(*buffer++);
	printser("\r\n");
}

void printser_buf_asc(unsigned char* buffer, unsigned int len)
{
	unsigned int adr;
	unsigned char ascii[17],c,cnt;
	
	adr = 0;
	cnt = 0;

	ascii[16]=0;
	while(len--)
	{
		if(!cnt)
		{
			printser_2hex(adr);
			printser(": ");
		}
		
		c = *buffer++;
		printser_2hex(c);
		if((c < ' ') || (c > 'z'))
			c = '.';
		ascii[cnt++] = c;
		adr++;
		
		if(cnt == 16)
		{
			printser("\t");
			printser(ascii);
			printser("\r\n");
			cnt = 0;
		}
	}
	if(cnt)
	{
		ascii[cnt] = 0;
		printser("\t");
		printser(ascii);
	}
	printser("\r\n");
}

void uart_sendbyte(unsigned char c)
{
#ifdef USE_UART0
	while(!ti_u0c1);
	u0tb = c;
#endif
#ifdef USE_UART1
	while(!ti_u1c1);
	u1tb = c;
#endif
}
